<?php
/**
 * @package		Remarkety
 * @copyright	Copyright Interamind Ltd © 2014 - All rights reserved.
 * @license		GNU/GPL
 * @author		Remarkety 
 * @author mail	support@remarkety.com
 * @website		www.remarkety.com
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );
jimport('joomla.utilities.date');
require_once JPATH_SITE.DS.'components'.DS.'com_remarkety'.DS.'remarketyLogger.php';

class remarketyModelRemarkety extends Jmodel
{
	var $vendor = null;
	var $real_time_zone = null;
	
	function __construct(){
		$this->real_time_zone = date_default_timezone_get();
		parent::__construct();
	}
	
	public function getShoppers($limit, $page, $since_id, $updated_at_min, &$debugInfo){
		$where = " address_type='BT' ";
		
		if(!empty($since_id)){
			$where .= " AND user_id > ".$since_id;
		}
		
		if(!empty($updated_at_min)){
			$date = new DateTime($updated_at_min);
			$updated_at_min = $date->format('U');
			
			$where .= " AND mdate > ".$updated_at_min;
		}
		
		if(!empty($where)){
			$where = ' WHERE '.$where;
		}
		
		$ordering = ' order by mdate ASC';

        	$sql_limit = " LIMIT ".($limit*($page)).",".$limit ;
		
		$db = &JFactory::getDBO();

		$q = "SELECT user_id as virtuemart_user_id, country as virtuemart_country_id, zip, user_email as email, first_name, last_name, mdate as modifiedOn, cdate as createdOn 
		 FROM #__vm_user_info ".$where.$ordering.$sql_limit;
		
		$debugInfo[] = "getShoppers() query: $q";
		
		$db->setQuery($q);
		$rows = $db->loadObjectList('virtuemart_user_id');
		
		$count = 0;
	 	foreach ($rows as $row) {
			$date = new JDate($row->modifiedOn);
			$row->modifiedOn = $date->toMySQL();
			
			$date = new JDate($row->createdOn);
			$row->createdOn = $date->toMySQL();
			
			$count++;
		}
		$debugInfo[] = "getShoppers() loaded $count rows";
		return $rows ;		
	}
	
	/**
	 * 
	 * @param $limit
	 * @param $page
	 * @param $since_id
	 * @param $created_at_min
	 * @param $created_at_max
	 * @param $updated_at_min
	 * @param $updated_at_max
	 * @param $order_status
	 * @param $order_id
	 * @return array
	 */
	public function getOrders($limit = '50', $page = '0', $since_id, $created_at_min, $created_at_max, $updated_at_min, $updated_at_max, $order_status, $order_id, &$debugInfo){
		
		$where = "";
		remarketyLogger::log('getOrders Start', remarketyLogger::LEVEL_DEBUG);
		$params_debug = 'Params limit='.$limit." Page=".$page." created_at_min=".$created_at_min." created_at_max=".$created_at_max." updated_at_min=".$updated_at_min." updated_at_max=".$updated_at_max." order_status=". $order_status." order_id=".$order_id;
		$debugInfo[] = $params_debug;
		remarketyLogger::log($params_debug, remarketyLogger::LEVEL_DEBUG);

		if(!empty($since_id)){
			$where .= " order_id > ".$since_id;
		}
		
		if(!empty($created_at_min)){
			$date = new DateTime($created_at_min);
			$created_at_min = $date->format('U');
			
			$created_at_min_where = " cdate > ".$created_at_min;
			if(!empty($where)){
				$created_at_min_where = " AND ".$created_at_min_where;
			} 
			$where .= $created_at_min_where;
		}
		
		if(!empty($created_at_max)){
			$date = new DateTime($created_at_max);
			$created_at_max = $date->format('U');
			
			$created_at_max_where = " cdate < ".$created_at_max;
			if(!empty($where)){
				$created_at_max_where = " AND ".$created_at_max_where;
			} 
			$where .= $created_at_max_where;
		}
		
		if(!empty($updated_at_min)){
			$date = new DateTime($updated_at_min);
			$updated_at_min = $date->format('U');
			
			$updated_at_min_where = " mdate > ".$updated_at_min;
			if(!empty($where)){
				$updated_at_min_where = " AND ".$updated_at_min_where;
			} 
			$where .= $updated_at_min_where;
		}
		
		if(!empty($updated_at_max)){
			$date = new DateTime($updated_at_max);
			$updated_at_max = $date->format('U');
			
			$updated_at_max_where = " mdate < ".$updated_at_max;
			if(!empty($where)){
				$updated_at_max_where = " AND ".$updated_at_max_where;
			} 
			$where .= $updated_at_max_where;
		}
		
		if(!empty($order_status)){
			if(!is_array($order_status)){
				$order_status_arr = explode(',', $order_status);
			}
			foreach ($order_status_arr as &$status){
				$status = "'" . $status . "'";
			}
			$status_list_sql = implode(',', $order_status_arr);
			$order_status_where = sprintf(" a.order_status IN (%s)", $status_list_sql);
			if(!empty($where)){
				$order_status_where = " AND ".$order_status_where;
			} 
			$where .= $order_status_where;
		}
		
		if(!empty($order_id) && is_numeric($order_id)){
			$order_id_where = " order_id=".$order_id;
			if(!empty($where)){
				$order_id_where = " AND ".$order_id_where;
			} 
			$where .= $order_id_where;
		}
		
		$ordering = ' ORDER BY mdate ASC ';
		
		$sql_limit = " LIMIT ".($limit*($page)).",".$limit ;
		if(!empty($where)){
			$where = ' WHERE '.$where;
		}
		$db = &JFactory::getDBO();
		$q = "SELECT order_id FROM #__vm_orders ".$where.$ordering.$sql_limit;
		
		$debugInfo[] = "getOrders() query: $q";
		
		$db->setQuery($q);
		
		$rows = $db->loadResultArray();
		
		$result = array();
		
		foreach ($rows as $row) {
			$result[$row] = $this->getOrderById($row);
		}
		
		return $result;
	}
	
	private function getOrderById($order_id){
		global $CURRENCY_DISPLAY;
		
		$order = array('items'=>array(), 'details'=>array(), 'history'=>array());
		$db = &JFactory::getDBO();
		
		$q = "SELECT o.order_total, o.coupon_discount, o.order_discount, o.order_id as order_number, o.order_total, o.order_shipping, 
			o.order_shipping_tax, o.user_id as virtuemart_user_id, o.coupon_code, o.cdate as created_on, o.mdate as modified_on, o.order_status, 
			o.order_currency, 
			u.user_email as email, u.country as virtuemart_country_id, u.zip, u.first_name, u.last_name, 
			s.order_status_name 
			FROM #__vm_orders o	LEFT JOIN #__vm_order_status s ON s.order_status_code = o.order_status 
			LEFT JOIN #__vm_order_user_info u ON u.order_id = o.order_id	
			WHERE o.order_id=".$order_id;
		
		$db->setQuery($q);
		$order_row = $db->loadObject();
		
		$date = new JDate($order_row->created_on);
		$cdate = $date->toMySQL();
		$order['created_on'] = $cdate;
		
		$date = new JDate($order_row->modified_on);
		$mdate = $date->toMySQL();
		$order['modified_on'] = $mdate;

		$order['currency_code_3'] = $order_row->order_currency;
		$order['currency_name'] = $order_row->order_currency;
		$order['currency_symbol'] = $CURRENCY_DISPLAY->getSymbol();
		$order['virtuemart_order_id'] = $order_id;
		$order['order_number'] = $order_id;
		
		$order['order_total'] = $order_row->order_total;
		$order['orderShipping'] = $order_row->order_shipping + $order_row->order_shipping_tax;
		$order['coupon_discount'] = $order_row->coupon_discount;
		$order['order_discount'] = $order_row->order_discount;
		$order['coupon_code'] = $order_row->coupon_code;
		
		$order['status_code'] = $order_row->order_status;
//		$order['statusName'] = $order_row->order_status_name;
			
		$order['details']['BT']->virtuemart_user_id = $order_row->virtuemart_user_id;
		$order['details']['BT']->virtuemart_country_id = $order_row->virtuemart_country_id;
		$order['details']['BT']->zip = $order_row->zip;
		$order['details']['BT']->email = $order_row->email;
		$order['details']['BT']->first_name = $order_row->first_name;
		$order['details']['BT']->last_name = $order_row->last_name;
		
		
		// Get the order history
		/*$q = "SELECT a.order_status_code, a.date_added as created_on, b.order_status_name, b.order_status_id as virtuemart_orderstate_id 
			FROM #__vm_order_history a JOIN  #__vm_order_status b 
			ON a.order_status_code = b.order_status_code 
			WHERE order_id=".$order_id." 
			ORDER BY order_status_history_id DESC";
		
		$db->setQuery($q);
		$order['history'] = $db->loadObject();*/
		
		// Get the order items
		$q = 'SELECT order_item_id as virtuemart_order_item_id, product_quantity, order_item_name, order_item_sku, i.product_id as virtuemart_product_id, product_item_price,
		    product_final_price, product_attribute, order_status, category_id as virtuemart_category_id 
		   FROM (#__vm_order_item i LEFT JOIN #__vm_product p ON p.product_id = i.product_id) 
		   LEFT JOIN #__vm_product_category_xref c ON p.product_id = c.product_id 
		   WHERE `order_id`="'.$order_id.'" group by `order_item_id`';

		$db->setQuery($q);
		$order['items'] = $db->loadObjectList();
		
		if(!empty($order['items'])){
			foreach ($order['items'] as $item){
				$image_thumb = $this->getImageUrl($item->virtuemart_product_id);
				$item->image_thumb = $image_thumb;
			}
		}
		
		return $order;
	}
	
	public function getProducts($limit, $page, $since_id, $handle, $vendor, $product_type, $collection_id, 
        			$created_at_min, $created_at_max, $updated_at_min, $updated_at_max, $published_at_min, $published_at_max, $published_status, $product_id, &$debugInfo){
       			
		$where = "";
		
		if(!empty($since_id)){
			$where .= " product_id > ".$since_id;
		}
		
		if(!empty($vendor)){
			$vendor_where = " vendor_id = '".$vendor."'";
			if(!empty($where)){
				$vendor_where = " AND ".$vendor_where;
			} 
			$where .= $vendor_where;
		}
		
        	if(!empty($created_at_min)){
			$date = new DateTime($created_at_min);
			$created_at_min = $date->format('U');
			
			$created_at_min_where = " cdate > ".$created_at_min;
			if(!empty($where)){
				$created_at_min_where = " AND ".$created_at_min_where;
			} 
			$where .= $created_at_min_where;
		}
		
		if(!empty($created_at_max)){
			$date = new DateTime($created_at_max);
			$created_at_max = $date->format('U');
			
			$created_at_max_where = " cdate < ".$created_at_max;
			if(!empty($where)){
				$created_at_max_where = " AND ".$created_at_max_where;
			} 
			$where .= $created_at_max_where;
		}
		
		if(!empty($updated_at_min)){
			$date = new DateTime($updated_at_min);
			$updated_at_min = $date->format('U');
			
			$updated_at_min_where = " mdate > ".$updated_at_min;
			if(!empty($where)){
				$updated_at_min_where = " AND ".$updated_at_min_where;
			} 
			$where .= $updated_at_min_where;
		}
		
		if(!empty($updated_at_max)){
			$date = new DateTime($updated_at_max);
			$updated_at_max = $date->format('U');
			
			$updated_at_max_where = " mdate < ".$updated_at_max;
			if(!empty($where)){
				$updated_at_max_where = " AND ".$updated_at_max_where;
			} 
			$where .= $updated_at_max_where;
		}
		
		/*if($published_status !== null){
			$published_status_where = " published  '".$published_status."'";
			if(!empty($where)){
				$published_status_where = " AND ".$published_status_where;
			} 
			$where .= $published_status_where;
		}*/
		
		if(!empty($product_id)){
			$product_id_where = " product_id=".$product_id;
			if(!empty($where)){
				$product_id_where = " AND ".$product_id_where;
			} 
			$where .= $product_id_where;
		}
		
		if(!empty($where)){
			$where = ' WHERE '.$where;
		}
		
		$ordering = ' order by mdate ASC';

        	$sql_limit = " LIMIT ".($limit*($page)).",".$limit ;
		
		$db = &JFactory::getDBO();
		$q = "SELECT product_id as virtuemart_product_id, product_sku, product_name, mdate as modified_on FROM #__vm_product ".$where.$ordering.$sql_limit;
		
		$debugInfo[] = "getProducts() query: ".$q;
		
		$db->setQuery($q);
		$debugInfo[] = "getProduct() query: $q";
		$rows = $db->loadObjectList('virtuemart_product_id');
		
		if($rows !== null){
			$count = 0;
			foreach ($rows as $row) {
				$row->productThumbPath = $this->getImageUrl($row->virtuemart_product_id);
				$date = new JDate($row->modified_on);
				$row->modified_on = $date->toMySQL();
				
				$row->categories = $this->getProductCategories($row->virtuemart_product_id);
				$count++;
			}
			$debugInfo[] = "getProducts() loaded $count rows";
			return $rows;
		}
		return null;
		
	}
	
	private function getProductCategories($product_id) {
		$db = &JFactory::getDBO();
		$cat_query = 'SELECT c.category_name 
			 FROM #__vm_product p JOIN #__vm_product p2	
			 ON p2.product_id = (IF(p.product_parent_id = 0, p.product_id, p.product_parent_id)) 
			 JOIN #__vm_product_category_xref cx ON cx.product_id=p2.product_id 
			 JOIN #__vm_category c ON c.category_id=cx.category_id 
			 WHERE p.product_id='.$product_id;
		
		$db->setQuery($cat_query);
		$categories = $db->loadObjectList();

		$catNameArr = array();
		if(!empty($categories)){
			foreach ($categories as $category_row) {
				$name = $category_row->category_name;
				$catNameArr[] = $name;
			}
		}
		return $catNameArr;
	}

	public function getShopSettings(&$debugInfo){
		include_class( "vendor" );
		global $ps_vendor, $CURRENCY_DISPLAY;
		if(empty($this->vendor)){
			$db = &JFactory::getDBO();
			$q = "SELECT vendor_id, vendor_store_name as name, contact_first_name, contact_last_name, contact_email as email, vendor_full_image as logoPath, cdate as created_at, mdate, 
					CONCAT(vendor_address_1, vendor_address_2) as address, vendor_url as domain, vendor_city as city, vendor_state as province, vendor_country as country, country_2_code, country_3_code,
					vendor_zip as zip, vendor_phone as phone, vendor_currency as currency, vendor_currency_display_style as money_with_currency_format, vendor_date_format, state_name 
				FROM (`#__vm_vendor` v, `#__vm_country` c)
				LEFT JOIN #__vm_state s ON (v.vendor_state=s.state_2_code AND s.country_id=c.country_id)
				WHERE `v`.`vendor_id`=1 
				AND (`v`.`vendor_country`=`c`.`country_2_code` OR `v`.`vendor_country`=`c`.`country_3_code`);";
			
			$db->setQuery($q);
			$rows = $db->loadObjectList();
			if(!empty($rows)){
				$vendor = $rows[0];
				$currencyArr = $ps_vendor->get_currency_display_style( $vendor->money_with_currency_format );
				$format = '{symbol}{number}';
				switch ($currencyArr['positive']){
					case 0:
						$format = '{number}{symbol}';
						break;
					case 2:
						$format = '{symbol}{number}';
						break;
					case 3:
						$format = '{symbol} {number}';
						break;
					case 1:
					default :
						$format = '{number} {symbol}';
						break;
				}
				
				$vendor->money_format = $format;
				$vendor->money_with_currency_format = $format;
				$config		= JFactory::getConfig();
				$tzoffset	= 'Etc/GMT'.$config->getValue('config.offset');
				$vendor->timezone = $tzoffset;
				$vendor->logoPath = IMAGEURL."vendor/".$vendor->logoPath;
				$vendor->created_at = date('Y-m-d H:i:s', $vendor->created_at);
				$vendor->shop_owner = $vendor->contact_first_name.' '.$vendor->contact_last_name;
				
				$this->vendor = $vendor;
			}
		}
		return $this->vendor;
	}
	
	public function getShoppersCount(){
    	$db = &JFactory::getDBO();
		$q = 'SELECT COUNT(1) FROM `#__vm_user_info` WHERE `address_type`= "BT" '; 
		$db->setQuery($q);
		$count = $db->loadResult();
		return $count;
	}
	
	public function getOrdersCount(){
		$db = &JFactory::getDBO();
		$q = 'SELECT COUNT(1) FROM `#__vm_orders`'; 
		$db->setQuery($q);
		$count = $db->loadResult();
		return $count;
	}
	
	public function getProductsCount(){
		$db = &JFactory::getDBO();
		$q = 'SELECT COUNT(1) FROM `#__vm_product`'; 
		$db->setQuery($q);
		$count = $db->loadResult();
		return $count;
	}
	
	public function getCarts($limit, $page, $since_id, $updated_at_min, $updated_at_max, &$debugInfo){
		$where = "c.cart_content != 'a:1:{s:3:\"idx\";i:0;}'";
		$result = array();
		remarketyLogger::log('getCarts updated_at_min='.$updated_at_min . ", limit=" . $limit . ", page=" . $page, remarketyLogger::LEVEL_DEBUG);
		
		if($updated_at_min === null  || empty($updated_at_min)){
			$allTime = new JDate('1970-01-01 00:00:00');
			$updated_at_min = $allTime->toMySQL();
		}
		$date = new JDate($updated_at_min);
		$time = $date->toMySQL();
		
		if($updated_at_min !== null){
			$updated_at_min_where = " last_updated > '".$time."'";
			if(!empty($where)){
				$updated_at_min_where = " AND ".$updated_at_min_where;
			} 
			$where .= $updated_at_min_where;
		}
		
		if(!empty($where)){
			$where = ' WHERE '.$where.' AND u.address_type="BT" ';
		}
		
		$ordering = ' order by last_updated ASC';
		$sql_limit = " LIMIT ".($limit*($page)).",".$limit ;
		
		
		$db = &JFactory::getDBO();

		$q = "SELECT c.user_id, user_email, first_name, last_name, cart_content, last_updated 
			FROM #__vm_cart c JOIN #__vm_user_info u ON c.user_id=u.user_id ".$where.$ordering.$sql_limit;
		remarketyLogger::log('carts sql: ' . $q, remarketyLogger::LEVEL_DEBUG);
		$db->setQuery($q);
		$result = $db->loadAssocList('user_id');
		//$result2 = $db->loadAssocList();
		remarketyLogger::log('count: ' . count($result), remarketyLogger::LEVEL_DEBUG);
		$carts = null;
		
		if(!empty($result)){
			$carts = array();
			foreach ($result as $userId=>$row){
				$cartContent = unserialize($row['cart_content']);
				
				if($cartContent['idx'] != 0){
					//there are products in this cart
					if($cart = $this->getCartData($cartContent)){
						$last_updated_obj = new DateTime($row['last_updated'], new DateTimeZone($this->real_time_zone) );
						$last_updated_obj->setTimezone(new DateTimeZone('UTC'));
						$last_updated = $last_updated_obj->format('Y-m-d H:i:s');
						 
						$cart['modifiedOn'] = $last_updated;
						$cart['email'] = $row['user_email'];
						$cart['firstName'] = $row['first_name'];
						$cart['lastName'] = $row['last_name'];
						
						$carts[] = $cart;
					}
				}
			}
		}
		
		return $carts;
	}
	
	private function getCartData($cart){
		global $CURRENCY_DISPLAY;
		require_once(CLASSPATH. 'ps_product.php' );
		$ps_product = new ps_product;

		$total = $order_taxable = $order_tax = 0;
		$amount = 0;
		$i=0;
		$up_limit = $cart["idx"] ;
		$ci = 0;
		
		$result = array();
		$db = &JFactory::getDBO();

		do
		{
			$items_arr = array();
			$product_id = $cart[$i]["product_id"];
			
			if(empty($product_id))
				return false;

			$desc = $cart[$i]["description"];
			$desc = empty($desc) ? '' : $desc;
			$price = $ps_product->get_adjusted_attribute_price($product_id, $desc);
			
			$q = "SELECT product_sku, product_name FROM #__vm_product WHERE product_id=".$product_id;
			$db->setQuery($q);
			$product_row = $db->loadAssoc();
			
			if(empty($product_row))
				return false;
				
			$sku =  $product_row['product_sku'];
			$productTitle = $product_row['product_name'];
			$productPrice = $price["product_price"];
			$quantity = $cart[$i]["quantity"];
			
			if(empty($sku) || empty($productTitle) || null == $productPrice || empty($quantity))
				return false;
			
			$items_arr['sku'] =  $sku;
			$items_arr['productTitle'] = $productTitle;
			$items_arr['storeProductId'] = $product_id;
			$items_arr['productPrice'] = $productPrice;
			$items_arr['quantity'] = $quantity;
			$items_arr['link'] = $this->getProductLink($product_id);
			
			$result['items'][] = $items_arr;
			
			$price["product_price"] = $GLOBALS['CURRENCY']->convert( $price["product_price"], $price["product_currency"] );
			$amount += $cart[$i]["quantity"];
			$product_parent_id=$ps_product->get_field($cart[$i]["product_id"],"product_parent_id");
//			if (@$auth["show_price_including_tax"] == 1) {
				$my_taxrate = $ps_product->get_product_taxrate($cart[$i]["product_id"] );
				$price["product_price"] *= ($my_taxrate+1);
//			}
			$subtotal = round( $price["product_price"], 2 ) * $cart[$i]["quantity"];
			$total += $subtotal;
			$i++;
			$ci++;
			
		}while ($i != $up_limit);
		
		
		$result['cartTotal'] = $total;
		
		$result['shipping'] = '';
		$result['couponCode'] = '';
		$result['couponDiscount'] = '';
		$result['otherDiscount'] = '';
		
		$debugInfo = array();
		$shop = $this->getShopSettings($debugInfo);
		
		$result['currency'] = $shop->currency; //$currency->currency_code_3;
		$result['money_with_currency_format'] = $shop->money_with_currency_format; 
		$result['money_format'] = $shop->money_format; 
		
		$result['currency_code_3'] = $shop->country_3_code; 
		$result['currency_name'] = $shop->country_3_code; 
		$result['currency_symbol'] = $CURRENCY_DISPLAY->getSymbol(); 
		
		return $result;
	}

	private static function unserializeSession($session_data) {
		try{
			$method = ini_get("session.serialize_handler");
			$dataArr = array();
			switch ($method) {
				case "php":
					$dataArr =  self::unserialize_php($session_data);
					break;
				case "php_binary":
					$dataArr = self::unserialize_phpbinary($session_data);
					break;
				default:
					$dataArr = false;
			}
			return $dataArr;
		}
		catch (Exception $e){
			return false;
		}
	}

	private static function unserialize_php($session_data) {
		$return_data = array();
		$offset = 0;
		while ($offset < strlen($session_data)) {
			if (!strstr(substr($session_data, $offset), "|")) {
				throw new Exception("invalid data, remaining: " . substr($session_data, $offset));
			}
			$pos = strpos($session_data, "|", $offset);
			$num = $pos - $offset;
			$varname = substr($session_data, $offset, $num);
			$offset += $num + 1;
			$data = unserialize(substr($session_data, $offset));
			$return_data[$varname] = $data;
			$offset += strlen(serialize($data));
		}
		return $return_data;
	}

	private static function unserialize_phpbinary($session_data) {
		$return_data = array();
		$offset = 0;
		while ($offset < strlen($session_data)) {
			$num = ord($session_data[$offset]);
			$offset += 1;
			$varname = substr($session_data, $offset, $num);
			$offset += $num;
			$data = unserialize(substr($session_data, $offset));
			$return_data[$varname] = $data;
			$offset += strlen(serialize($data));
		}
		return $return_data;
	}
					
	public function createCoupon($coupon_code, $percent_or_total, $gift_or_permanent, $coupon_value, $startDate, $expiryDate, $validFromValue, &$debugInfo){
		remarketyLogger::log('createCoupon coupon_code='.$coupon_code, remarketyLogger::LEVEL_DEBUG);
		
		if($percent_or_total == 'awo' && $this->isAwoInstalled()){
			$templateID = $coupon_value;
			$this->createDynamicCouponAWO($coupon_code, $templateID, $expiryDate, $debugInfo);
		}else{
			$coupon = array(
		        'coupon_code' =>  $coupon_code,
		        'percent_or_total' => strtolower($percent_or_total), 
		        'coupon_type' => strtolower($gift_or_permanent),
		        'coupon_value' => (float)$coupon_value
			);
			
			if($this->add_coupon_code($coupon)){
				$this->createRemarketyCoupon($coupon_code, $startDate, $expiryDate);
				return true;
			}
		}
		
		
		return false;
	}
	
	function createRemarketyCoupon($coupon_code, $startDate = null, $expiryDate = null){
		remarketyLogger::log('createRemarketyCoupon coupon_code='.$coupon_code, remarketyLogger::LEVEL_DEBUG);
		$startDate = isset($start_date) && !is_null($start_date) ? $start_date : '';
		$expiryDate = isset($expire_date) && !is_null($expire_date) ? $expire_date : '';
		$db = JFactory::getDbo();
		$sql = "INSERT INTO #__remarkety_coupons (coupon_code, start_date, expiration_date)  
						VALUES ('$coupon_code', '$startDate', '$expiryDate')";
		
		$db->setQuery($sql);
		$db->query();
				
		remarketyLogger::log('createRemarketyCoupon End', remarketyLogger::LEVEL_DEBUG);
	}
	
	function deleteExpiredCoupons(){
		remarketyLogger::log('deleteExpiredCoupons() start', remarketyLogger::LEVEL_DEBUG);
		$db = JFactory::getDbo();
		$q = 'DELETE FROM `#__remarkety_coupons` WHERE coupon_expiry_date < NOW() AND coupon_expiry_date IS NOT NULL';
		$db->setQuery($q);
		$res = $db->query();
		remarketyLogger::log('deleteExpiredCoupons() end', remarketyLogger::LEVEL_DEBUG);
	}
	
	private function createDynamicCouponAWO($coupon_code, $templateID, $expiryDate, &$debugInfo){
			if(empty($coupon_code)){
				$debugInfo[] = "Coupon code is empty. Dynamic AWO Coupon was not created.";
				return false;
			}
			
			if(!is_numeric($templateID)){
				$debugInfo[] = "Template ID format is not numeric.";
				return false;
			}
			
			if(empty($expiryDate) || !is_numeric($expiryDate) ){
				$expiryDate = null;
			}
			
			$list = awoAutoGenerate::getCouponTemplates();
			$isIdExists = false;
			if(!is_array($list)){
				$debugInfo[] = "AwoCoupon template ID was not found: ".$templateID;
				return false;
			}else{
				foreach ($list as $arr) {
					if($arr->id == $templateID){
						$isIdExists = true;
						break;
					}
					
				}
				if(!$isIdExists){
					$debugInfo[] = "AwoCoupon template ID was not found: ".$templateID;
					return false;
				}
			}
			
			$obj = awoAutoGenerate::generateCoupon($templateID, $coupon_code, $expiryDate);
			if($obj === false){
				$debugInfo[] = "AwoCoupon was not able to generate coupon from this template ID: ".$templateID;
				return false;
			}

			return true;
	}
	
	function add_coupon_code( &$d ) {
		remarketyLogger::log('*** add_coupon_code() coupon_code = '.$d['coupon_code'], remarketyLogger::LEVEL_DEBUG);
		
	    $coupon_code = $d['coupon_code'];
		$percent_or_total = strtolower($d['percent_or_total']) == 'percent' ? 'percent' : 'total';
		$coupon_type = strtolower($d['coupon_type']) == 'gift' ? 'gift' : 'permanent';
		$coupon_value = (float)$d['coupon_value'];
	
		$fields = array(
						'coupon_code' => $coupon_code,
						'percent_or_total' => $percent_or_total,
						'coupon_type' => $coupon_type,
						'coupon_value' => $coupon_value
					);
					
		$sql = "INSERT INTO #__vm_coupons (coupon_code,percent_or_total,coupon_type,coupon_value)  
						VALUES ('$coupon_code', '$percent_or_total',  '$coupon_type', $coupon_value)";
		
		remarketyLogger::log('*** add_coupon_code() SQL = '.$sql, remarketyLogger::LEVEL_DEBUG);
		$db = JFactory::getDBO();
		$db->setQuery($sql);
		
		if($db->query()) {
			remarketyLogger::log('*** add_coupon_code() db->query() = true', remarketyLogger::LEVEL_DEBUG);
			return true;
		}
		
		remarketyLogger::log('*** add_coupon_code() db->query() = false', remarketyLogger::LEVEL_DEBUG);
		return false;
    }

    public function getShopStatuses(&$debugInfo){
    	$db = &JFactory::getDBO();
    	$q = "SELECT order_status_name, order_status_code, order_status_id as virtuemart_orderstate_id FROM #__vm_order_status;";
    	$db->setQuery($q);
		$tatuses = $db->loadObjectList('order_status_code');
    	return $tatuses;
    }
    
	private function getImageUrl($product_id){
		global $mosConfig_live_site, $mosConfig_absolute_path;
		
		$db = &JFactory::getDBO();
		$thumb_query = 'SELECT p2.product_thumb_image, p.product_id as orig_prod_id,p.product_parent_id as orig_parent_id,p2.product_id as p2_prod_id,p2.product_parent_id as p2_parent_id
			 FROM #__vm_product p JOIN #__vm_product p2	
			 ON p2.product_id = (IF(p.product_parent_id = 0, p.product_id, p.product_parent_id))
			 WHERE p.product_id='.$product_id;
		$db->setQuery($thumb_query);
		$image = $db->loadResult();
		$url = VM_THEMEURL.'images/'.NO_IMAGE;
		
		if (!empty($image)) {
			
			$url = IMAGEURL.'product/'.$image;
			if( file_exists($image)) {
				$url = str_replace( $mosConfig_absolute_path, "", $image );
			} elseif( file_exists($mosConfig_absolute_path.'/'.$image)) {
				$url = $image;
			}
			$url = str_replace( basename( $url ), $GLOBALS['VM_LANG']->convert(basename($url)), $url );
		}
		
		return $url;
	}
	
	private function getProductLink($product_id){
		$prod_db = JFactory::getDBO();
		$q = "SELECT p.*, pc.category_id, c.category_flypage FROM #__vm_product p JOIN #__vm_product_category_xref pc ON p.product_id=pc.product_id JOIN #__vm_category c ON pc.category_id=c.category_id WHERE p.product_id=".$product_id;
		$prod_db->setQuery($q);
		$result = $prod_db->loadAssoc();
		
		$site_url =  JURI::base();
		 
		if(!empty($result)){
			$product = array();
			$flypage = $result["category_flypage"];
			if (empty($flypage)) {
	            $flypage = FLYPAGE;
	        }
	        $url_parameters = $site_url."?option=com_virtuemart&amp;page=shop.product_details&amp;flypage=".$flypage."&amp;product_id=".$result["product_id"]."&amp;category_id=".$result["category_id"];
	        return $url_parameters;
		}
		return null;
	}
	
	private function isAwoInstalled()
	{
		$success = false;
		
	    jimport('joomla.filesystem.file');
        if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_awocoupon'.DS.'helpers'.DS.'plgautogenerate.php')) 
        {
			include_once JPATH_ADMINISTRATOR.DS.'components'.DS.'com_awocoupon'.DS.'helpers'.DS.'plgautogenerate.php' ;
            $success = true;
        }
		return $success;
	}
}
?>